// Inspired by https://davidwalsh.name/browser-camera

var Tile = React.createClass({
  getInitialState: function() {
	return {'imgSrc':null}
  },
  tileClick: function(e){
	console.log("click! ", this.props.id);
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");
	var video = document.getElementById("video");
	context.drawImage(video, 0, 0, video.videoWidth, video.videoHeight);
	this.setState({'imgSrc': canvas.toDataURL("image/jpg")})
	this.props.onTileComplete(this.props.id);
  },
  render: function() {
  	var tileGuts;
	if (!this.state.imgSrc) { 
		tileGuts = <div className="tileContents">{this.props.id}</div>;
	} else {
		tileGuts = <img src={this.state.imgSrc}></img>;
	}

	return (
		<a onClick={this.tileClick}>
			<div className="tile">
				{tileGuts}
			</div>
		</a>
       );
  }
});

// Stolen from stackoverflow
Object.size = function(obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};


var Person = React.createClass({
  handleTileComplete: function(tileId){
	var completedNodes = this.state.completedNodes;
	completedNodes[tileId] = true;
	this.setState({'completedNodes': completedNodes});
	console.log("Finished with tile ", tileId, ", total completed is now ", Object.size(completedNodes));
	if (Object.size(completedNodes) == 6) {
		this.setState({'completionImage': this.props.person.finishImage});
	}
  },
  getInitialState: function() {
	return {'completionImage':null, 'completedNodes':{}}
  },
  render: function() {
    var onComplete = this.handleTileComplete;
    var tiles = [ {'id':1},
		  {'id':2},
		  {'id':3},
		  {'id':4},
		  {'id':5},
		  {'id':6} ];
    var tileNodes = tiles.map(function(tile){
	return  (
	    <Tile id={tile.id} key={tile.id} onTileComplete={onComplete} />
	);
    });
    
    // Everybody is a person... and has one gender... one you hear!
    var mainClass = "person " + this.props.person.sex; 
    return (
      <div className={mainClass}>
	<img className="finishImage" src={this.state.completionImage}></img>

        <h2 className="personName">
          <div >{this.props.person.name}</div>
        </h2>

	{tileNodes}


	<div className="clearfix" />
      </div>
    );
  }
});

var PeopleList = React.createClass({
  render: function() {
    var peopleNodes = this.props.data.map(function(person) {
      return (
        <Person person={person} key={person.id} />
      );
    });
    return (
      <div className="peopleList">
        {peopleNodes}
      </div>
    );
  }
});


var PickerUpperApp = React.createClass({
  getInitialState: function() {
    //return {data: [ ]};
    return {data: [ {'id':1, 'name':'Esther', 'sex':'girl', 'finishImage':'giphy.gif'}, 
		    {'id':2, 'name':'Mathew', 'sex':'boy', 'finishImage':'animated-dinosaur-image-0013.gif'} ]};
  },
  componentDidMount: function() {
	var canvas = document.getElementById("canvas"),
		context = canvas.getContext("2d"),
		video = document.getElementById("video"),
		videoObj = { "video": true },
		errBack = function(error) {
			console.log("Video capture error: ", error.code); 
		};

	if(navigator.getUserMedia) { // Standard
		navigator.getUserMedia(videoObj, function(stream) {
			video.src = stream;
			video.play();
		}, errBack);
	} else if(navigator.webkitGetUserMedia) { // WebKit-prefixed
		navigator.webkitGetUserMedia(videoObj, function(stream){
			video.src = window.webkitURL.createObjectURL(stream);
			video.play();
		}, errBack);
	}
	else if(navigator.mozGetUserMedia) { // Firefox-prefixed
		navigator.mozGetUserMedia(videoObj, function(stream){
			video.src = window.URL.createObjectURL(stream);
			video.play();
		}, errBack);
	}


  },
  render: function() {
    return (
      <div className="pickerAppContainer">
	 <video className="video" id="video" height="240px" autoPlay ></video>
	 <canvas className="videoCanvas" id="canvas" width="640px" height="480px"></canvas>
        <PeopleList data={this.state.data} />
      </div>
    );
  }
});


ReactDOM.render(
  <PickerUpperApp url="/api/currentTask " />,
  document.getElementById('content')
);
